package cz.jzitnik.game.sprites;

import cz.jzitnik.tui.ResourceLoader;
import cz.jzitnik.tui.Sprite;

public class Cow extends Sprite {
    public enum CowState{
        LEFT,
        RIGHT,
        LEFT_HURT,
        RIGHT_HURT
    }

    public String getSprite() {
        return getSprite(CowState.RIGHT);
    }

    public String getSprite(Enum e) {
        return ResourceLoader.loadResource(
                switch (e) {
                    case CowState.LEFT -> "mobs/cow/left.ans";
                    case CowState.RIGHT -> "mobs/cow/right.ans";
                    case CowState.LEFT_HURT -> "mobs/cow/lefthurt.ans";
                    case CowState.RIGHT_HURT -> "mobs/cow/righthurt.ans";
                    default -> throw new IllegalStateException("Unexpected value: " + e);
                }
        );
    }
}
