package cz.jzitnik.game.sprites;

import cz.jzitnik.tui.ResourceLoader;
import cz.jzitnik.tui.Sprite;

public class Sheep extends Sprite {
    public enum SheepState {
        WHITE_LEFT,
        WHITE_RIGHT,
        WHITE_LEFT_HURT,
        WHITE_RIGHT_HURT,

        LIGHT_GRAY_LEFT,
        LIGHT_GRAY_RIGHT,
        LIGHT_GRAY_LEFT_HURT,
        LIGHT_GRAY_RIGHT_HURT,

        GRAY_LEFT,
        GRAY_RIGHT,
        GRAY_LEFT_HURT,
        GRAY_RIGHT_HURT,

        BLACK_LEFT,
        BLACK_RIGHT,
        BLACK_LEFT_HURT,
        BLACK_RIGHT_HURT,

        BROWN_LEFT,
        BROWN_RIGHT,
        BROWN_LEFT_HURT,
        BROWN_RIGHT_HURT,

        PINK_LEFT,
        PINK_RIGHT,
        PINK_LEFT_HURT,
        PINK_RIGHT_HURT,
    }

    public String getSprite() {
        return getSprite(SheepState.WHITE_RIGHT);
    }

    public String getSprite(Enum e) {
        return ResourceLoader.loadResource(
                switch (e) {
                    case SheepState.WHITE_LEFT -> "mobs/sheep/white/left.ans";
                    case SheepState.WHITE_RIGHT -> "mobs/sheep/white/right.ans";
                    case SheepState.WHITE_LEFT_HURT -> "mobs/sheep/white/lefthurt.ans";
                    case SheepState.WHITE_RIGHT_HURT -> "mobs/sheep/white/righthurt.ans";

                    case SheepState.LIGHT_GRAY_LEFT -> "mobs/sheep/light_gray/left.ans";
                    case SheepState.LIGHT_GRAY_RIGHT -> "mobs/sheep/light_gray/right.ans";
                    case SheepState.LIGHT_GRAY_LEFT_HURT -> "mobs/sheep/light_gray/lefthurt.ans";
                    case SheepState.LIGHT_GRAY_RIGHT_HURT -> "mobs/sheep/light_gray/righthurt.ans";

                    case SheepState.GRAY_LEFT -> "mobs/sheep/gray/left.ans";
                    case SheepState.GRAY_RIGHT -> "mobs/sheep/gray/right.ans";
                    case SheepState.GRAY_LEFT_HURT -> "mobs/sheep/gray/lefthurt.ans";
                    case SheepState.GRAY_RIGHT_HURT -> "mobs/sheep/gray/righthurt.ans";

                    case SheepState.BLACK_LEFT -> "mobs/sheep/black/left.ans";
                    case SheepState.BLACK_RIGHT -> "mobs/sheep/black/right.ans";
                    case SheepState.BLACK_LEFT_HURT -> "mobs/sheep/black/lefthurt.ans";
                    case SheepState.BLACK_RIGHT_HURT -> "mobs/sheep/black/righthurt.ans";

                    case SheepState.BROWN_LEFT -> "mobs/sheep/brown/left.ans";
                    case SheepState.BROWN_RIGHT -> "mobs/sheep/brown/right.ans";
                    case SheepState.BROWN_LEFT_HURT -> "mobs/sheep/brown/lefthurt.ans";
                    case SheepState.BROWN_RIGHT_HURT -> "mobs/sheep/brown/righthurt.ans";

                    case SheepState.PINK_LEFT -> "mobs/sheep/pink/left.ans";
                    case SheepState.PINK_RIGHT -> "mobs/sheep/pink/right.ans";
                    case SheepState.PINK_LEFT_HURT -> "mobs/sheep/pink/lefthurt.ans";
                    case SheepState.PINK_RIGHT_HURT -> "mobs/sheep/pink/righthurt.ans";

                    default -> throw new IllegalStateException("Unexpected value: " + e);
                }
        );
    }
}